/***************************************************************************
 *            main.c
 *
 *  Thu Sep  7 21:11:47 2006
 *  Copyright  2006  Mike Dobbs
 *  Email spam at mdobbs.com
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <stdio.h>
#include <string.h>
#include <gtk/gtk.h>

#include "main.h"

GKeyFile *key_file;
gchar *filename;

void add(GtkButton *button, gpointer user_data)
{
	GtkListStore *list = (GtkListStore *) user_data;
	GtkWidget *dialog;

dialog = gtk_file_chooser_dialog_new ("Open File",
				      window,
				      GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER,
				      GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
				      GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
				      NULL);

if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_ACCEPT)
  {
    gchar *dir;
	GtkTreeIter iter;

    dir= gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));

	gtk_list_store_append(list,&iter);
	gtk_list_store_set(list,&iter,0,dir,-1);

	  
    g_free (dir);
  }

	gtk_widget_destroy (dialog);
	
	
}

void del(GtkButton *button, gpointer user_data)
{
	GtkTreeView *view = (GtkTreeView *) user_data;
	GtkTreeSelection *selection = gtk_tree_view_get_selection(view);
	GtkTreeIter iter;
	GtkTreeModel *model = gtk_tree_view_get_model(view);
	
	if (gtk_tree_selection_get_selected (selection,&model,&iter))
	{
		gtk_list_store_remove(GTK_LIST_STORE(model), &iter);				
	}	
}



void
save_config_file (GtkButton * button, gpointer user_data)
{
	FILE *cfg;
	GtkTreeIter iter;

	
	g_message ("Saving %s\n", filename);

	//WatchDirectoryRoots
	if (gtk_tree_model_get_iter_first(GTK_TREE_MODEL(WatchDirectoryRoots),&iter))
	{
		gchar **array = (gchar **) NULL;
		gsize length =0; //size of array
		gint i; // counter
		
		length++;
		
		//figure out length
		while (gtk_tree_model_iter_next(GTK_TREE_MODEL(WatchDirectoryRoots),&iter)) 
		{
			length++;
		}
		
		array = g_new0(gchar *, length +1);
		
		gtk_tree_model_get_iter_first(GTK_TREE_MODEL(WatchDirectoryRoots),&iter);
		for(i=0;i < (int) length;i++)
		{
			gchar *buffer = (gchar *) NULL;
			gtk_tree_model_get(GTK_TREE_MODEL(WatchDirectoryRoots),&iter,(int) 0,&buffer,-1);
	    	array[i] = buffer;			
			gtk_tree_model_iter_next(GTK_TREE_MODEL(WatchDirectoryRoots),&iter);		
		}
		
	
	
		 g_key_file_set_string_list(key_file,
					     "Watches",
					     "WatchDirectoryRoots",
					     (const gchar **)array, length);
		
		g_strfreev (array);
	}
	else
	{
		//remove watch dir?
		g_warning("Missing Watch Dir!\n");
		g_key_file_remove_key(key_file,
					     "Watches",
					     "WatchDirectoryRoots",
					     NULL);
	}	
	
	
	
	//NoWatchDirectory
	if (gtk_tree_model_get_iter_first(GTK_TREE_MODEL(NoWatchDirectory),&iter))
	{
		gchar **array = (gchar **) NULL;
		gsize length =0; //size of array
		gint i; // counter
		
		length++;
		
		//figure out length
		while (gtk_tree_model_iter_next(GTK_TREE_MODEL(NoWatchDirectory),&iter)) 
		{
			length++;
		}
		

		array = g_new0(gchar *, length +1);
		
		gtk_tree_model_get_iter_first(GTK_TREE_MODEL(NoWatchDirectory),&iter);
		for(i=0;i < (int) length;i++)
		{
			gchar *buffer = (gchar *) NULL;
			gtk_tree_model_get(GTK_TREE_MODEL(NoWatchDirectory),&iter,(int) 0,&buffer,-1);
	    	array[i] = buffer;			
			gtk_tree_model_iter_next(GTK_TREE_MODEL(NoWatchDirectory),&iter);		
		}
		
	
		 g_key_file_set_string_list(key_file,
					     "Watches",
					     "NoWatchDirectory",
					     (const gchar **)array, length);
		
		g_strfreev (array);
	}
	

	
	//store setting in key_file
	g_key_file_set_boolean (key_file, "Indexes", "IndexTextFiles",
				gtk_toggle_button_get_active
				(GTK_TOGGLE_BUTTON (IndexTextFiles)));
	g_key_file_set_boolean (key_file, "Indexes", "IndexDocuments",
				gtk_toggle_button_get_active
				(GTK_TOGGLE_BUTTON (IndexDocuments)));
	g_key_file_set_boolean (key_file, "Indexes", "IndexSourceCode",
				gtk_toggle_button_get_active
				(GTK_TOGGLE_BUTTON (IndexSourceCode)));
	g_key_file_set_boolean (key_file, "Indexes", "IndexScripts",
				gtk_toggle_button_get_active
				(GTK_TOGGLE_BUTTON (IndexScripts)));
	g_key_file_set_boolean (key_file, "Indexes", "IndexHTML",
				gtk_toggle_button_get_active
				(GTK_TOGGLE_BUTTON (IndexHTML)));
	g_key_file_set_boolean (key_file, "Indexes", "IndexPDF",
				gtk_toggle_button_get_active
				(GTK_TOGGLE_BUTTON (IndexPDF)));
	g_key_file_set_boolean (key_file, "Indexes", "IndexApplicationHelpFiles",
				gtk_toggle_button_get_active
				(GTK_TOGGLE_BUTTON (IndexApplicationHelpFiles)));
	g_key_file_set_boolean (key_file, "Indexes", "IndexDesktopFiles",
				gtk_toggle_button_get_active
				(GTK_TOGGLE_BUTTON (IndexDesktopFiles)));

	g_key_file_set_boolean (key_file, "Indexes", "IndexEpiphanyBookmarks",
				gtk_toggle_button_get_active
				(GTK_TOGGLE_BUTTON (IndexEpiphanyBookmarks)));

	g_key_file_set_boolean (key_file, "Indexes", "IndexEpiphanyHistory",
				gtk_toggle_button_get_active
				(GTK_TOGGLE_BUTTON (IndexEpiphanyHistory)));

	g_key_file_set_boolean (key_file, "Indexes", "IndexFirefoxBookmarks",
				gtk_toggle_button_get_active
				(GTK_TOGGLE_BUTTON (IndexFirefoxBookmarks)));

	g_key_file_set_boolean (key_file, "Indexes", "IndexFirefoxHistory",
				gtk_toggle_button_get_active
				(GTK_TOGGLE_BUTTON (IndexFirefoxHistory)));
				
	//database				
	g_key_file_set_boolean (key_file, "Database", "StoreTextFileContentsInDB",
				gtk_toggle_button_get_active
				(GTK_TOGGLE_BUTTON (StoreTextFileContentsInDB)));
				
	gchar *string;
	string = g_strdup_printf("%.1lfM",gtk_spin_button_get_value(DBBufferMemoryLimit));
	g_key_file_set_string(key_file,"Database","DBBufferMemoryLimit", string);
	g_free(string);


	cfg = fopen (filename, "w");

	if (cfg)
	{
		gchar *buffer;
		buffer = g_key_file_to_data (key_file, NULL, NULL);
		if (buffer)
			fputs (buffer, cfg);

		fclose (cfg);
		g_free (buffer);
	}

}

void
end_program (GtkWidget * widget, gpointer data)
{
	g_key_file_free (key_file);
	g_free (filename);

	gtk_main_quit ();
}

int
main (int argc, char **argv)
{
	gint row=0; // counter for rows
	
	gtk_init (&argc, &argv);

	//inits
	filename =
		g_build_filename (g_get_home_dir (), ".Tracker",
				  "tracker.cfg", NULL);
	key_file = g_key_file_new ();

	
	/* Create Widgets */

	window = g_object_new (GTK_TYPE_WINDOW,
			       "default-height", -1,
			       "default-width", -1,
			       "border-width", 12,
			       "title", "Tracker-Setup", NULL);

	scroll_window = g_object_new (GTK_TYPE_SCROLLED_WINDOW, "vscrollbar-policy",GTK_POLICY_AUTOMATIC,"hscrollbar-policy",GTK_POLICY_AUTOMATIC,"height-request",200,NULL);
	v_box = g_object_new (GTK_TYPE_VBOX, NULL);

	table = g_object_new (GTK_TYPE_TABLE, "n-columns", 14, "n-rows", 2,NULL);

	//WatchDirectoryRoots
	WatchDirectoryRoots = gtk_list_store_new(1,G_TYPE_STRING);
	WatchDirectoryRoots_view = g_object_new(GTK_TYPE_TREE_VIEW,"model",WatchDirectoryRoots,"headers-visible",FALSE,NULL);
	WatchDirectoryRoots_column = gtk_tree_view_column_new_with_attributes("Watch Directory",gtk_cell_renderer_text_new(),"text",0,NULL);
	gtk_tree_view_append_column(WatchDirectoryRoots_view,WatchDirectoryRoots_column);
	WatchDirectoryRoots_add = gtk_button_new_from_stock(GTK_STOCK_ADD);
	WatchDirectoryRoots_del = gtk_button_new_from_stock(GTK_STOCK_REMOVE);
	WatchDirectoryRoots_hbox =g_object_new (GTK_TYPE_HBOX, NULL);
	gtk_box_pack_start(GTK_BOX(WatchDirectoryRoots_hbox),WatchDirectoryRoots_add,TRUE,FALSE,2);
	gtk_box_pack_start(GTK_BOX(WatchDirectoryRoots_hbox),WatchDirectoryRoots_del,TRUE,FALSE,2);
	
	
	//NoWatchDirectory
	NoWatchDirectory = gtk_list_store_new(1,G_TYPE_STRING);
	NoWatchDirectory_view = g_object_new(GTK_TYPE_TREE_VIEW,"model",NoWatchDirectory,"headers-visible",FALSE,NULL);
	NoWatchDirectory_column = gtk_tree_view_column_new_with_attributes("Don't Watch Directory",gtk_cell_renderer_text_new(),"text",0,NULL);
	gtk_tree_view_append_column(NoWatchDirectory_view,NoWatchDirectory_column);
	NoWatchDirectory_add = gtk_button_new_from_stock(GTK_STOCK_ADD);
	NoWatchDirectory_del = gtk_button_new_from_stock(GTK_STOCK_REMOVE);
	NoWatchDirectory_hbox =g_object_new (GTK_TYPE_HBOX, NULL); 
	gtk_box_pack_start(GTK_BOX(NoWatchDirectory_hbox),NoWatchDirectory_add,TRUE,FALSE,2);
	gtk_box_pack_start(GTK_BOX(NoWatchDirectory_hbox),NoWatchDirectory_del,TRUE,FALSE,2);
	
	//indexes
	IndexTextFiles = g_object_new (GTK_TYPE_CHECK_BUTTON, NULL);
	IndexDocuments = g_object_new (GTK_TYPE_CHECK_BUTTON, NULL);
	IndexSourceCode = g_object_new (GTK_TYPE_CHECK_BUTTON, NULL);
	IndexScripts = g_object_new (GTK_TYPE_CHECK_BUTTON, NULL);
	IndexHTML = g_object_new (GTK_TYPE_CHECK_BUTTON, NULL);
	IndexPDF = g_object_new (GTK_TYPE_CHECK_BUTTON, NULL);
	IndexApplicationHelpFiles =
		g_object_new (GTK_TYPE_CHECK_BUTTON, NULL);
	IndexDesktopFiles = g_object_new (GTK_TYPE_CHECK_BUTTON, NULL);
	IndexEpiphanyBookmarks = g_object_new (GTK_TYPE_CHECK_BUTTON, NULL);
	IndexEpiphanyHistory = g_object_new (GTK_TYPE_CHECK_BUTTON, NULL);
	IndexFirefoxBookmarks = g_object_new (GTK_TYPE_CHECK_BUTTON, NULL);
	IndexFirefoxHistory = g_object_new (GTK_TYPE_CHECK_BUTTON, NULL);

	//Database
	StoreTextFileContentsInDB =
		g_object_new (GTK_TYPE_CHECK_BUTTON, NULL);
	StoreTextFileContentsInDB_adjustment = GTK_ADJUSTMENT(gtk_adjustment_new(1.0,0.1,10.0,.1,1,0.0));
	DBBufferMemoryLimit = g_object_new (GTK_TYPE_SPIN_BUTTON, "adjustment",StoreTextFileContentsInDB_adjustment,"digits",1,"value",1,NULL);

	//Save Button
	save = g_object_new (GTK_TYPE_BUTTON, "label", "Save", NULL);


	/* pack */
	gtk_container_add (GTK_CONTAINER (window), GTK_WIDGET (v_box));
	gtk_box_pack_start (GTK_BOX (v_box),
			    GTK_WIDGET (g_object_new
					(GTK_TYPE_LABEL, "label",
					 "<b>Include in Search</b>",
					 "use-markup", TRUE, NULL)), FALSE,
		    FALSE, 2);				
				
	gtk_box_pack_start (GTK_BOX (v_box), GTK_WIDGET (WatchDirectoryRoots_view), FALSE,
			    FALSE, 2);
				
	gtk_box_pack_start (GTK_BOX (v_box), GTK_WIDGET (WatchDirectoryRoots_hbox), FALSE,
			    FALSE, 2);

	gtk_box_pack_start (GTK_BOX (v_box),
			    GTK_WIDGET (gtk_hseparator_new()),FALSE,FALSE,2);
	

	gtk_box_pack_start (GTK_BOX (v_box),
			    GTK_WIDGET (g_object_new
					(GTK_TYPE_LABEL, "label",
					 "<b>Exclude in Search</b>",
					 "use-markup", TRUE, NULL)), FALSE,
			    FALSE, 2);
	gtk_box_pack_start (GTK_BOX (v_box), GTK_WIDGET (NoWatchDirectory_view), FALSE,
			    FALSE, 2);
	
	gtk_box_pack_start (GTK_BOX (v_box), GTK_WIDGET (NoWatchDirectory_hbox), FALSE,
			    FALSE, 2);
				
	gtk_box_pack_start (GTK_BOX (v_box),
			    GTK_WIDGET (gtk_hseparator_new()),FALSE,FALSE,2);
				

	//add scroll_window/table
	gtk_box_pack_start (GTK_BOX (v_box), GTK_WIDGET (scroll_window), TRUE, TRUE,
			    2);

	gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW (scroll_window), GTK_WIDGET (table));				
	
	gtk_box_pack_start (GTK_BOX (v_box), GTK_WIDGET (save), FALSE, FALSE,
			    2);

	/* indexes */
	gtk_table_attach (GTK_TABLE (table),
			  GTK_WIDGET (g_object_new
				      (GTK_TYPE_LABEL, "label",
				       "<b>Indexes</b>", "use-markup", TRUE,
				       NULL)), 0, 2, row, (row +1), 0, 0, 1, 1);
	row++;

	gtk_table_attach (GTK_TABLE (table),
			  GTK_WIDGET (gtk_label_new ("Index Text Files")), 0,
			  1, row, (row +1), 0, 0, 1, 1);
	gtk_table_attach (GTK_TABLE (table), GTK_WIDGET (IndexTextFiles), 1,
			  2, row, (row +1), 0, 0, 1, 1);			  
	row++;
	

	gtk_table_attach (GTK_TABLE (table),
			  GTK_WIDGET (gtk_label_new ("Index Documents")), 0,
			  1, row, (row +1), 0, 0, 1, 1);
	gtk_table_attach (GTK_TABLE (table), GTK_WIDGET (IndexDocuments), 1,
			  2, row, (row +1), 0, 0, 1, 1);
	row++;

	gtk_table_attach (GTK_TABLE (table),
			  GTK_WIDGET (gtk_label_new ("Index Source Code")), 0,
			  1, row, (row +1), 0, 0, 1, 1);			  
	gtk_table_attach (GTK_TABLE (table), GTK_WIDGET (IndexSourceCode), 1,
			  2, row, (row +1), 0, 0, 1, 1);
	row++;


	gtk_table_attach (GTK_TABLE (table),
			  GTK_WIDGET (gtk_label_new ("Index Scripts")), 0, 1,
			  row, (row+1), 0, 0, 1, 1);
	gtk_table_attach (GTK_TABLE (table), GTK_WIDGET (IndexScripts), 1, 2,
			  row, (row +1), 0, 0, 1, 1);
	row++;
	
	
	gtk_table_attach (GTK_TABLE (table),
			  GTK_WIDGET (gtk_label_new ("Index PDF Files")), 0, 1, row,
			  (row +1), 0, 0, 1, 1);
	gtk_table_attach (GTK_TABLE (table), GTK_WIDGET (IndexPDF), 1, 2, row,
			  (row +1), 0, 0, 1, 1);
	row++;
	
	gtk_table_attach (GTK_TABLE (table),
			  GTK_WIDGET (gtk_label_new ("Index Help Files")), 0, 1, row,
			  (row +1), 0, 0, 1, 1);
	gtk_table_attach (GTK_TABLE (table), GTK_WIDGET (IndexApplicationHelpFiles), 1, 2, row,
			  (row +1), 0, 0, 1, 1);
	row++;
	
	gtk_table_attach (GTK_TABLE (table),
			  GTK_WIDGET (gtk_label_new ("Index Desktop Files")), 0, 1, row,
			  (row +1), 0, 0, 1, 1);
	gtk_table_attach (GTK_TABLE (table), GTK_WIDGET (IndexDesktopFiles), 1, 2, row,
			  (row +1), 0, 0, 1, 1);
	row++;
	
	gtk_table_attach (GTK_TABLE (table),
			  GTK_WIDGET (gtk_label_new ("Index Epiphany Bookmarks")), 0, 1, row,
			  (row +1), 0, 0, 1, 1);
	gtk_table_attach (GTK_TABLE (table), GTK_WIDGET (IndexEpiphanyBookmarks), 1, 2, row,
			  (row +1), 0, 0, 1, 1);
	row++;
	
	gtk_table_attach (GTK_TABLE (table),
			  GTK_WIDGET (gtk_label_new ("Index Ephiphany History")), 0, 1, row,
			  (row +1), 0, 0, 1, 1);
	gtk_table_attach (GTK_TABLE (table), GTK_WIDGET (IndexEpiphanyHistory), 1, 2, row,
			  (row +1), 0, 0, 1, 1);
	row++;
	
		
	gtk_table_attach (GTK_TABLE (table),
			  GTK_WIDGET (gtk_label_new ("Index FireFox Bookmarks")), 0, 1, row,
			  (row +1), 0, 0, 1, 1);
	gtk_table_attach (GTK_TABLE (table), GTK_WIDGET (IndexFirefoxBookmarks), 1, 2, row,
			  (row +1), 0, 0, 1, 1);
	row++;	
	
	gtk_table_attach (GTK_TABLE (table),
			  GTK_WIDGET (gtk_label_new ("Index FireFox History")), 0, 1, row,
			  (row +1), 0, 0, 1, 1);
	gtk_table_attach (GTK_TABLE (table), GTK_WIDGET (IndexFirefoxHistory), 1, 2, row,
			  (row +1), 0, 0, 1, 1);
	row++;	
	
	//Database
	
	gtk_table_attach (GTK_TABLE (table),
			  GTK_WIDGET (gtk_hseparator_new()), 0, 2, row, (row +1), 0, 0, 1, 1);
	row++;
	
	gtk_table_attach (GTK_TABLE (table),
			  GTK_WIDGET (g_object_new
				      (GTK_TYPE_LABEL, "label",
				       "<b>Database</b>", "use-markup", TRUE,"xalign",1.0,
				       NULL)), 0, 2, row, (row +1), 0, 0, 1, 1);
	row++;

	gtk_table_attach (GTK_TABLE (table),
			  GTK_WIDGET (gtk_label_new ("Store File Contents in DB")), 0, 1, row,
			  (row +1), 0, 0, 1, 1);
	gtk_table_attach (GTK_TABLE (table), GTK_WIDGET (StoreTextFileContentsInDB), 1, 2, row,
			  (row +1), 0, 0, 1, 1);
	row++;	
	
	gtk_table_attach (GTK_TABLE (table),
			  GTK_WIDGET (gtk_label_new ("DB Buffer Memory Limit")), 0, 1, row,
			  (row +1), 0, 0, 1, 1);
	gtk_table_attach (GTK_TABLE (table), GTK_WIDGET (DBBufferMemoryLimit), 1, 2, row,
			  (row +1), 0, 0, 1, 1);
	row++;	
	



	/* signals */
	g_signal_connect (window, "delete-event", G_CALLBACK (end_program),
			  NULL);
	g_signal_connect (window, "destroy-event", G_CALLBACK (end_program),
			  NULL);

	g_signal_connect (save, "clicked", G_CALLBACK (save_config_file),
			  (gpointer) NULL);
			  
	g_signal_connect (WatchDirectoryRoots_add, "clicked", G_CALLBACK (add),
			  (gpointer) WatchDirectoryRoots);
	g_signal_connect (WatchDirectoryRoots_del, "clicked", G_CALLBACK (del),
			  (gpointer) WatchDirectoryRoots_view);

	g_signal_connect (NoWatchDirectory_add, "clicked", G_CALLBACK (add),
			  (gpointer) NoWatchDirectory);
	g_signal_connect (NoWatchDirectory_del, "clicked", G_CALLBACK (del),
			  (gpointer) NoWatchDirectory_view);


	load_config_file ();


	gtk_widget_show_all (GTK_WIDGET (window));
	gtk_main ();

	return (0);
}

void
load_config_file ()
{
	gchar **values;
	gint i;
	
	if (!g_file_test (filename, G_FILE_TEST_EXISTS))
	{
		gchar *contents;
		
		contents = g_strconcat ("[Watches]\n",
					"WatchDirectoryRoots=",
					g_get_home_dir (), ";\n",
					"NoWatchDirectory=\n\n\n",
					"[Indexes]\n" "IndexTextFiles=true\n",
					"IndexDocuments=true\n",
					"IndexSourceCode=true\n",
					"IndexScripts=true\n",
					"IndexHTML=true\n", "IndexPDF=true\n",
					"IndexApplicationHelpFiles=true\n",
					"IndexDesktopFiles=true\n",
					"IndexEpiphanyBookmarks=true\n"
					"IndexEpiphanyHistory=true\n",
					"IndexFirefoxBookmarks=true\n",
					"IndexFirefoxHistory=true\n\n",
					"[Database]\n",
					"StoreTextFileContentsInDB=false\n",
					"DBBufferMemoryLimit=1M\n", NULL);

		g_file_set_contents (filename, contents, strlen (contents),
				     NULL);
		g_free (contents);
	}

	/* load all options into hashtable for fast retrieval */
	g_key_file_load_from_file (key_file, filename, G_KEY_FILE_NONE, NULL);

	values = g_key_file_get_string_list (key_file,
					     "Watches",
					     "WatchDirectoryRoots",
					     NULL, NULL);

	if (values)
	{
		for (i = 0; values[i] != NULL; i++) 
		{
			GtkTreeIter iter;
			gtk_list_store_append(WatchDirectoryRoots,&iter);
			gtk_list_store_set(WatchDirectoryRoots,&iter,0,values[i],-1);
		}

		g_strfreev (values);
	}


	values = g_key_file_get_string_list (key_file,
					     "Watches",
					     "NoWatchDirectory", NULL, NULL);

	if (values)
	{
		for (i = 0; values[i] != NULL; i++) 
		{
			GtkTreeIter iter;
			gtk_list_store_append(NoWatchDirectory,&iter);
			gtk_list_store_set(NoWatchDirectory,&iter,0,values[i],-1);
		}

		g_strfreev (values);
	}


	
	if (g_key_file_has_key (key_file, "Indexes", "IndexTextFiles", NULL))
	{
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON
					      (IndexTextFiles),
					      g_key_file_get_boolean
					      (key_file, "Indexes",
					       "IndexTextFiles", NULL));
	}

	if (g_key_file_has_key (key_file, "Indexes", "IndexDocuments", NULL))
	{
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON
					      (IndexDocuments),
					      g_key_file_get_boolean
					      (key_file, "Indexes",
					       "IndexDocuments", NULL));
	}

	if (g_key_file_has_key (key_file, "Indexes", "IndexSourceCode", NULL))
	{
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON
					      (IndexSourceCode),
					      g_key_file_get_boolean
					      (key_file, "Indexes",
					       "IndexSourceCode", NULL));
	}

	if (g_key_file_has_key (key_file, "Indexes", "IndexScripts", NULL))
	{
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON
					      (IndexScripts),
					      g_key_file_get_boolean
					      (key_file, "Indexes",
					       "IndexScripts", NULL));
	}

	if (g_key_file_has_key (key_file, "Indexes", "IndexHTML", NULL))
	{
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (IndexHTML),
					      g_key_file_get_boolean
					      (key_file, "Indexes",
					       "IndexHTML", NULL));
	}

	if (g_key_file_has_key (key_file, "Indexes", "IndexPDF", NULL))
	{
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (IndexPDF),
					      g_key_file_get_boolean
					      (key_file, "Indexes",
					       "IndexPDF", NULL));
	}

	if (g_key_file_has_key
	    (key_file, "Indexes", "IndexApplicationHelpFiles", NULL))
	{
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON
					      (IndexApplicationHelpFiles),
					      g_key_file_get_boolean
					      (key_file, "Indexes",
					       "IndexApplicationHelpFiles",
					       NULL));
	}

	if (g_key_file_has_key
	    (key_file, "Indexes", "IndexDesktopFiles", NULL))
	{
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON
					      (IndexDesktopFiles),
					      g_key_file_get_boolean
					      (key_file, "Indexes",
					       "IndexDesktopFiles", NULL));
	}

	if (g_key_file_has_key
	    (key_file, "Indexes", "IndexEpiphanyBookmarks", NULL))
	{
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON
					      (IndexEpiphanyBookmarks),
					      g_key_file_get_boolean
					      (key_file, "Indexes",
					       "IndexEpiphanyBookmarks",
					       NULL));
	}

	if (g_key_file_has_key
	    (key_file, "Indexes", "IndexEpiphanyHistory", NULL))
	{
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON
					      (IndexEpiphanyHistory),
					      g_key_file_get_boolean
					      (key_file, "Indexes",
					       "IndexEpiphanyHistory", NULL));
	}

	if (g_key_file_has_key
	    (key_file, "Indexes", "IndexFirefoxBookmarks", NULL))
	{
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON
					      (IndexFirefoxBookmarks),
					      g_key_file_get_boolean
					      (key_file, "Indexes",
					       "IndexFirefoxBookmarks", NULL));
	}

	if (g_key_file_has_key
	    (key_file, "Indexes", "IndexFirefoxHistory", NULL))
	{
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON
					      (IndexFirefoxHistory),
					      g_key_file_get_boolean
					      (key_file, "Indexes",
					       "IndexFirefoxHistory", NULL));
	}

	
	//Database
	if (g_key_file_has_key
	    (key_file, "Database", "StoreTextFileContentsInDB", NULL))
	{
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON
					      (StoreTextFileContentsInDB),
					      g_key_file_get_boolean
					      (key_file, "Database",
					       "StoreTextFileContentsInDB", NULL));
	}

	if (g_key_file_has_key
	    (key_file, "Database", "DBBufferMemoryLimit", NULL))
	{
		gchar *string = g_key_file_get_string(key_file,"Database","DBBufferMemoryLimit", NULL);
		gdouble MemLimit;
		
		sscanf(string,"%lfM",&MemLimit);
		
		gtk_spin_button_set_value(DBBufferMemoryLimit,MemLimit);
		
		g_free(string);
	}

	
}
