/***************************************************************************
 *            main.h
 *
 *  Thu Sep  7 21:11:47 2006
 *  Copyright  2006  Mike Dobbs
 *  Email spam at mdobbs.com
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _MAIN_H
#define _MAIN_H

#define BUFFER_SIZE 200 //size of buffer when reading cfg file

	GtkWindow *window; 
	GtkVBox *v_box;
	
	GtkTreeView *includes;
	GtkTreeView *excludes;
	
	GtkScrolledWindow *scroll_window;
	GtkTable *table;
	
	//includes
	GtkListStore *WatchDirectoryRoots;
	GtkTreeView *WatchDirectoryRoots_view;
	GtkTreeViewColumn *WatchDirectoryRoots_column;
	GtkWidget *WatchDirectoryRoots_add;	
	GtkWidget *WatchDirectoryRoots_del;
	GtkHBox *WatchDirectoryRoots_hbox;
	
	//excludes
	GtkListStore *NoWatchDirectory;
	GtkTreeView *NoWatchDirectory_view;
	GtkTreeViewColumn *NoWatchDirectory_column;
	GtkWidget *NoWatchDirectory_add;	
	GtkWidget *NoWatchDirectory_del;
	GtkHBox *NoWatchDirectory_hbox;
	
	//indexes
	GtkCheckButton *IndexTextFiles;
	GtkCheckButton *IndexDocuments;
	GtkCheckButton *IndexSourceCode;
	GtkCheckButton *IndexScripts;
	GtkCheckButton *IndexHTML;
	GtkCheckButton *IndexPDF;
	GtkCheckButton *IndexApplicationHelpFiles;
	GtkCheckButton *IndexDesktopFiles;
	GtkCheckButton *IndexEpiphanyBookmarks;
	GtkCheckButton *IndexEpiphanyHistory;
	GtkCheckButton *IndexFirefoxBookmarks;
	GtkCheckButton *IndexFirefoxHistory;
	
	//Database
	GtkCheckButton *StoreTextFileContentsInDB;
	GtkSpinButton *DBBufferMemoryLimit;
	GtkAdjustment *StoreTextFileContentsInDB_adjustment;
	
	//Save Button
	GtkButton *save;

void end_program(GtkWidget *widget, gpointer data);		
void load_config_file ();
void add(GtkButton *button, gpointer user_data);
void del(GtkButton *button, gpointer user_data);


#endif /* _MAIN_H */
